//--------------------------------------------------------------------------------------------------
//
// Title       : No Title
// Design      : lab2_solution
// Author      : cse
// Company     : uw
//
//-------------------------------------------------------------------------------------------------
//
// File        : Z:\my_designs\Lab2_Solution\compile\SerialUART.v
// Generated   : Tue Aug 29 17:38:19 2006
// From        : Z:\my_designs\Lab2_Solution\src\SerialUART.bde
// By          : Bde2Verilog ver. 2.01
//
//-------------------------------------------------------------------------------------------------
//
// Description : 
//
//-------------------------------------------------------------------------------------------------
`ifdef _VCP
`else
`define library(a,b)
`endif


// ---------- Design Unit Header ---------- //
`timescale 1ps / 1ps

module SerialUART (RS232_RTS_IN,RS_232_RX_DATA,clk,reset,InAddress,InData,InWE,Size,RS_232_CTS_OUT,RS_232_TX_DATA,DataOut) /* synthesis syn_black_box */ ;

// ------------ Port declarations --------- //
input RS232_RTS_IN;
wire RS232_RTS_IN;
input RS_232_RX_DATA;
wire RS_232_RX_DATA;
input clk;
wire clk;
input reset;
wire reset;
input [5:0] InAddress;
wire [5:0] InAddress;
input [31:0] InData;
wire [31:0] InData;
input InWE;
wire InWE;
input [1:0]	Size;
wire [1:0] Size;
output RS_232_CTS_OUT;
wire RS_232_CTS_OUT;
output RS_232_TX_DATA;
wire RS_232_TX_DATA;
output [31:0] DataOut;
wire [31:0] DataOut;

//synopsys translate_off

// ----------- Signal declarations -------- //
wire NET1011;
wire NET1031;
wire NET226;
wire NET241;
wire NET275;
wire NET354;
wire NET402;
wire NET838;
wire NET853;
wire NET895;
wire NET967;
wire [7:0] BUS76;
wire [7:0] BUS887;
wire [7:0] BUS917;
wire [7:0] BUS94;
wire [7:0] BUS98;
wire [7:0] BUS999;

// -------- Component instantiations -------//

async_receiver U1
(
	.RxD(RS_232_RX_DATA),
	.RxD_data(BUS98),
	.RxD_data_ready(NET354),
	.clk(clk)
);



SerialFIFO U2
(
	.clk(clk),
	.fifoEmpty(NET226),
	.fifoFull(NET241),
	.inData(BUS94),
	.nextData(NET402),
	.outData(BUS76),
	.readclk(clk),
	.reset(reset),
	.writeData(NET275)
);



SerialRecvManager U3
(
	.CTS(RS_232_CTS_OUT),
	.RTS(RS232_RTS_IN),
	.RecvFIFODataOut(BUS94),
	.RecvFIFOFull(NET241),
	.RecvFIFOWrite(NET275),
	.RxDataReady(NET354),
	.clk(clk),
	.reset(reset),
	.serialDataIn(BUS98)
);



MemoryMappedSerialManager U4
(
	.InAddress(InAddress),
	.InData(InData),
	.InWE(InWE),
	.Size(Size),
	.OutData(DataOut),
	.RecvFIFOEmpty(NET226),
	.RecvFIFORead(NET402),
	.RecvFIFOTop(BUS76),
	.SendFIFOFull(NET853),
	.SendFIFOWrite(NET1031),
	.clk(clk),
	.reset(reset),
	.sendFIFOData(BUS999)
);



SerialSendManager U5
(
	.TxD_Busy(NET967),
	.TxD_Start(NET895),
	.TxData(BUS917),
	.clk(clk),
	.reset(reset),
	.sendFIFOEmpty(NET838),
	.sendFIFORead(NET1011),
	.sendFIFOTop(BUS887)
);



async_transmitter U6
(
	.TxD(RS_232_TX_DATA),
	.TxD_busy(NET967),
	.TxD_data(BUS917),
	.TxD_start(NET895),
	.clk(clk)
);



SerialFIFO U7
(
	.clk(clk),
	.fifoEmpty(NET838),
	.fifoFull(NET853),
	.inData(BUS999),
	.nextData(NET1011),
	.outData(BUS887),
	.readclk(clk),
	.reset(reset),
	.writeData(NET1031)
);

//synopsys translate_on

endmodule 

// RS-232 RX module
// (c) fpga4fun.com KNJN LLC - 2003, 2004, 2005, 2006

module async_receiver(clk, RxD, RxD_data_ready, RxD_data, RxD_endofpacket, RxD_idle) /* synthesis syn_black_box */ ;
input clk, RxD;
output RxD_data_ready;  // onc clock pulse when RxD_data is valid
output [7:0] RxD_data;

parameter ClkFrequency = 50000000; //50000000; // 50MHz
parameter Baud = 57600;

// We also detect if a gap occurs in the received stream of characters
// That can be useful if multiple characters are sent in burst
//  so that multiple characters can be treated as a "packet"
output RxD_endofpacket;  // one clock pulse, when no more data is received (RxD_idle is going high)
output RxD_idle;  // no data is being received

//synopsys translate_off

// Baud generator (we use 8 times oversampling)
parameter Baud8 = Baud*8;
parameter Baud8GeneratorAccWidth = 16;
wire [Baud8GeneratorAccWidth:0] Baud8GeneratorInc = ((Baud8<<(Baud8GeneratorAccWidth-7))+(ClkFrequency>>8))/(ClkFrequency>>7);
reg [Baud8GeneratorAccWidth:0] Baud8GeneratorAcc;
always @(posedge clk) Baud8GeneratorAcc <= Baud8GeneratorAcc[Baud8GeneratorAccWidth-1:0] + Baud8GeneratorInc;
wire Baud8Tick = Baud8GeneratorAcc[Baud8GeneratorAccWidth];

////////////////////////////
reg [1:0] RxD_sync_inv;
always @(posedge clk) if(Baud8Tick) RxD_sync_inv <= {RxD_sync_inv[0], ~RxD};
// we invert RxD, so that the idle becomes "0", to prevent a phantom character to be received at startup

reg [1:0] RxD_cnt_inv;
reg RxD_bit_inv;

always @(posedge clk)
if(Baud8Tick)
begin
	if( RxD_sync_inv[1] && RxD_cnt_inv!=2'b11) RxD_cnt_inv <= RxD_cnt_inv + 2'b01;
	else 
	if(~RxD_sync_inv[1] && RxD_cnt_inv!=2'b00) RxD_cnt_inv <= RxD_cnt_inv - 2'b01;

	if(RxD_cnt_inv==2'b00) RxD_bit_inv <= 1'b0;
	else
	if(RxD_cnt_inv==2'b11) RxD_bit_inv <= 1'b1;
end

reg [3:0] state;
reg [3:0] bit_spacing;

// "next_bit" controls when the data sampling occurs
// depending on how noisy the RxD is, different values might work better
// with a clean connection, values from 8 to 11 work
wire next_bit = (bit_spacing==4'd10);

always @(posedge clk)
if(state==0)
	bit_spacing <= 4'b0000;
else
if(Baud8Tick)
	bit_spacing <= {bit_spacing[2:0] + 4'b0001} | {bit_spacing[3], 3'b000};

always @(posedge clk)
if(Baud8Tick)
case(state)
	4'b0000: if(RxD_bit_inv) state <= 4'b1000;  // start bit found?
	4'b1000: if(next_bit) state <= 4'b1001;  // bit 0
	4'b1001: if(next_bit) state <= 4'b1010;  // bit 1
	4'b1010: if(next_bit) state <= 4'b1011;  // bit 2
	4'b1011: if(next_bit) state <= 4'b1100;  // bit 3
	4'b1100: if(next_bit) state <= 4'b1101;  // bit 4
	4'b1101: if(next_bit) state <= 4'b1110;  // bit 5
	4'b1110: if(next_bit) state <= 4'b1111;  // bit 6
	4'b1111: if(next_bit) state <= 4'b0001;  // bit 7
	4'b0001: if(next_bit) state <= 4'b0000;  // stop bit
	default: state <= 4'b0000;
endcase

reg [7:0] RxD_data;
always @(posedge clk)
if(Baud8Tick && next_bit && state[3]) RxD_data <= {~RxD_bit_inv, RxD_data[7:1]};

reg RxD_data_ready, RxD_data_error;
always @(posedge clk)
begin
	RxD_data_ready <= (Baud8Tick && next_bit && state==4'b0001 && ~RxD_bit_inv);  // ready only if the stop bit is received
	RxD_data_error <= (Baud8Tick && next_bit && state==4'b0001 &&  RxD_bit_inv);  // error if the stop bit is not received
end

reg [4:0] gap_count;
always @(posedge clk) if (state!=0) gap_count<=5'b0; else if(Baud8Tick & ~gap_count[4]) gap_count <= gap_count + 5'b1;
assign RxD_idle = gap_count[4];
reg RxD_endofpacket; always @(posedge clk) RxD_endofpacket <= Baud8Tick & (gap_count==5'b01111);

	//synopsys translate_on
	
endmodule

// RS-232 TX module
// (c) fpga4fun.com KNJN LLC - 2003, 2004, 2005, 2006

//`define DEBUG   // in DEBUG mode, we output one bit per clock cycle (useful for faster simulations)

module async_transmitter(clk, TxD_start, TxD_data, TxD, TxD_busy) /* synthesis syn_black_box */ ;
input clk, TxD_start;
input [7:0] TxD_data;
output TxD, TxD_busy;

//synopsys translate_off

parameter ClkFrequency = 50000000;	// 25MHz
parameter Baud = 57600;
parameter RegisterInputData = 1;	// in RegisterInputData mode, the input doesn't have to stay valid while the character is been transmitted

// Baud generator
parameter BaudGeneratorAccWidth = 16;
reg [BaudGeneratorAccWidth:0] BaudGeneratorAcc;
`ifdef DEBUG
wire [BaudGeneratorAccWidth:0] BaudGeneratorInc = 17'h10000;
`else
wire [BaudGeneratorAccWidth:0] BaudGeneratorInc = ((Baud<<(BaudGeneratorAccWidth-4))+(ClkFrequency>>5))/(ClkFrequency>>4);
`endif

wire BaudTick = BaudGeneratorAcc[BaudGeneratorAccWidth];
wire TxD_busy;
always @(posedge clk) if(TxD_busy) BaudGeneratorAcc <= BaudGeneratorAcc[BaudGeneratorAccWidth-1:0] + BaudGeneratorInc;

// Transmitter state machine
reg [3:0] state;
wire TxD_ready = (state==0);
assign TxD_busy = ~TxD_ready;

reg [7:0] TxD_dataReg;
always @(posedge clk) if(TxD_ready & TxD_start) TxD_dataReg <= TxD_data;
wire [7:0] TxD_dataD = RegisterInputData ? TxD_dataReg : TxD_data;

always @(posedge clk)
case(state)
	4'b0000: if(TxD_start) state <= 4'b0001;
	4'b0001: if(BaudTick) state <= 4'b0100;
	4'b0100: if(BaudTick) state <= 4'b1000;  // start
	4'b1000: if(BaudTick) state <= 4'b1001;  // bit 0
	4'b1001: if(BaudTick) state <= 4'b1010;  // bit 1
	4'b1010: if(BaudTick) state <= 4'b1011;  // bit 2
	4'b1011: if(BaudTick) state <= 4'b1100;  // bit 3
	4'b1100: if(BaudTick) state <= 4'b1101;  // bit 4
	4'b1101: if(BaudTick) state <= 4'b1110;  // bit 5
	4'b1110: if(BaudTick) state <= 4'b1111;  // bit 6
	4'b1111: if(BaudTick) state <= 4'b0010;  // bit 7
	4'b0010: if(BaudTick) state <= 4'b0011;  // stop1
	4'b0011: if(BaudTick) state <= 4'b0000;  // stop2
	default: if(BaudTick) state <= 4'b0000;
endcase

// Output mux
reg muxbit;
always @( * )
case(state[2:0])
	3'd0: muxbit <= TxD_dataD[0];
	3'd1: muxbit <= TxD_dataD[1];
	3'd2: muxbit <= TxD_dataD[2];
	3'd3: muxbit <= TxD_dataD[3];
	3'd4: muxbit <= TxD_dataD[4];
	3'd5: muxbit <= TxD_dataD[5];
	3'd6: muxbit <= TxD_dataD[6];
	3'd7: muxbit <= TxD_dataD[7];
endcase

// Put together the start, data and stop bits
reg TxD;
always @(posedge clk) TxD <= (state<4) | (state[3] & muxbit);  // register the output to make it glitch free
	
	//synopsys translate_on

endmodule

module MemoryMappedSerialManager(clk, reset, InAddress, InData, Size, InWE, SendFIFOFull, RecvFIFOEmpty, RecvFIFORead, RecvFIFOTop, SendFIFOWrite, sendFIFOData,OutData) /* synthesis syn_black_box */;
	//Standard in/out ports for the IO Interface
	input [5:0] InAddress;
	//Input size is still 32 bits since we can send words.
	input [31:0] InData;
	input InWE;
	input [1:0] Size;
	//Output size still 32 bits since processor takes 32 bit chunks from memory
	output reg [31:0] OutData; 
	
	//Non-IO Interface stuff
	input clk, reset;
	
	//Serial in/out control ports
	output reg [7:0] sendFIFOData;
	input [7:0] RecvFIFOTop;
	
	input SendFIFOFull, RecvFIFOEmpty;
	
	output reg RecvFIFORead;
	output reg SendFIFOWrite;
	
	//synopsys translate_off
		
	always @(InAddress or RecvFIFOEmpty or RecvFIFOTop or SendFIFOFull) begin
		//Output
		//Is data present for reading
		if(InAddress == 0) begin
			OutData[31:1] = 0;
			OutData[0] = ~RecvFIFOEmpty;
		end
		
		//What is the byte at front of the queue?
		else if(InAddress == 1) begin
			OutData[31:16] = 24'h000000;
			OutData[15:8] = RecvFIFOTop[7:0];
			OutData[7:0] = 8'h00;
		end
		
		//Can I send data?
		else if(InAddress == 2) begin
			OutData[31:17] = 15'b0;
			OutData[16] = ~SendFIFOFull; 
			OutData[15:0] = 16'b0;
		end
		
		//All other cases:
		else begin
			OutData[31:0] = 32'h00000000;
		end
		
	end		 
	
	always @(posedge clk) begin
		if(reset) begin
			RecvFIFORead = 0;
			SendFIFOWrite = 0;
		end
		
		else begin
			sendFIFOData[7:0] = InData[7:0];
			if((InAddress == 3) && (InWE) && (Size == 2'b01)) begin
				RecvFIFORead = 1;
			end
				
			else if((InAddress == 4) && (InWE)) begin
				SendFIFOWrite = 1;	
			end				 
			
			else begin
				RecvFIFORead = 0;
				SendFIFOWrite = 0;
			end	
		end
	end
	//synopsys translate_on
endmodule

module SerialFIFO(inData, outData, writeData, nextData, fifoEmpty, fifoFull, clk, readclk, reset) /* synthesis syn_black_box */;
	input [7:0] inData;
	input clk, readclk, reset, writeData, nextData;
	output [7:0] outData;
	output wire fifoEmpty, fifoFull;
	
	//synopsys translate_off
	
	//Provide an 8 deep buffer of bytes 
	
	reg[7:0] dataBuffer[7:0];
	
	reg[2:0] currentWriteLocation;
	reg[2:0] currentReadLocation;
	
	assign fifoFull = (currentReadLocation[2:0]==(currentWriteLocation[2:0] + 3'b001));
	assign fifoEmpty = (currentReadLocation==currentWriteLocation);
	
	assign outData = dataBuffer[currentReadLocation];
	
	always @(posedge readclk) begin	
		if(reset) begin
			currentReadLocation = 0;
		end
		else begin
			if (~fifoEmpty && nextData)	currentReadLocation = currentReadLocation + 3'b001;						
		end
	end
		
	always @(posedge clk) begin
		if(reset) begin
			currentWriteLocation = 0;
		end
		else begin
			if(~fifoFull && writeData) begin
				dataBuffer[currentWriteLocation] = inData;
				currentWriteLocation = currentWriteLocation + 3'b001;	
			end				
		end
	end
	
	//synopsys translate_on
	
endmodule

module SerialRecvManager(clk, reset, RxDataReady, serialDataIn, RecvFIFODataOut, RecvFIFOFull, RecvFIFOWrite, RTS, CTS) /* synthesis syn_black_box */;
	input[7:0] serialDataIn;
	input RTS, RecvFIFOFull, clk, reset, RxDataReady;
	
	output reg [7:0] RecvFIFODataOut;
	output reg CTS, RecvFIFOWrite;
	
	//synopsys translate_off
	
	reg [7:0] commandBuffer;
	
	reg[1:0] state;
	reg[1:0] nextState;
	
	parameter WAITRECV = 0;
	parameter READDATA = 1;
	parameter SENDTOFIFO = 2;
	parameter CLEARSENDTOFIFO = 3;
	
	always @(posedge clk) begin
		if(reset) begin
			state = WAITRECV;
			nextState = WAITRECV;
			RecvFIFOWrite = 0;
			CTS = 1;
		end
		
		else begin
			case (state)
				WAITRECV:
				begin
					if(~RecvFIFOFull) begin
						CTS = 0;
						RecvFIFOWrite = 0;
						if(RxDataReady) begin
							CTS = 1;
							nextState = READDATA;
						end
						else begin
							nextState = WAITRECV;
						end
					end
					else begin
						CTS = 1;
						nextState = WAITRECV;
					end
				end
				
				READDATA:
				begin
					RecvFIFOWrite = 0;
					commandBuffer = serialDataIn;
					nextState = SENDTOFIFO;
				end
				
				SENDTOFIFO:
				begin
					RecvFIFOWrite = 1;
					RecvFIFODataOut = commandBuffer;
					nextState = CLEARSENDTOFIFO;
				end
				
				CLEARSENDTOFIFO:
				begin
					RecvFIFOWrite = 0;
					nextState = WAITRECV;
				end
			endcase
			state = nextState;
		end
	end
	
	//synopsys translate_on
endmodule

module SerialSendManager(reset, clk, sendFIFOTop, sendFIFOEmpty, sendFIFORead, TxData, TxD_Start, TxD_Busy) /* synthesis syn_black_box */;
	input reset, clk, TxD_Busy, sendFIFOEmpty;
	input [7:0] sendFIFOTop;
	output wire [7:0] TxData;
	output reg sendFIFORead, TxD_Start;	
	
	//synopsys translate_off
	
	reg[1:0] state;
	reg[1:0] nextState;
	
	parameter IDLE = 0;
	parameter SENDDATA = 1;
	parameter SENDFIFONEXT = 2;
	parameter SENDFIFOCLEAR = 3;
	
	assign TxData = sendFIFOTop[7:0];
	
	always @(posedge clk) begin
		if(reset) begin
			state = IDLE;
			nextState = IDLE;
			sendFIFORead = 0;
			TxD_Start = 0;
		end
		
		else begin		
			case (state)
				IDLE:
				begin
					sendFIFORead = 0;
					TxD_Start = 0;
					if(sendFIFOEmpty) begin
						nextState = IDLE;
					end
					else begin
						nextState = SENDDATA;
					end
				end
				
				SENDDATA:
				begin
					if(~TxD_Busy) begin
						TxD_Start = 1;
						nextState = SENDFIFOCLEAR;
					end
					else begin
						TxD_Start = 0;
						nextState = SENDDATA;
					end
				end
				
				SENDFIFOCLEAR:
				begin
					TxD_Start = 0;
					sendFIFORead = 1;
					nextState = SENDFIFONEXT;
				end
				
				SENDFIFONEXT:
				begin
					TxD_Start = 0;
					sendFIFORead = 0;
					nextState = IDLE;
				end
			endcase
			
			state = nextState;
		end
	end
	
	//synopsys translate_on
endmodule